﻿Imports System.Configuration
Imports System.IO
Imports DlpLibDemoVB
Imports DlpLibDemoVB.DlpLibDemoVB
Imports DlpLibDemoVB.My.Resources
Imports Nautilus

Public Class MainForm

	Public Shared scannedText As String = ""
	Private reader As SerialReader
	Private cfg As Config = Config.[Default]

	Private _dl As New DriverLicense()


	Public Sub New()
		InitializeComponent()
		Text = Application.ProductName
		AddHandler cfg.SettingChanging, AddressOf Default_SettingChanging

		InitializeMenu()
	End Sub

	Private Sub UnsubscribeAll()
		UnsubscribeReader()
		RemoveHandler cfg.SettingChanging, AddressOf Default_SettingChanging
	End Sub

	Private Sub Default_SettingChanging(sender As Object, e As System.Configuration.SettingChangingEventArgs)
		DirectCast(sender, ApplicationSettingsBase).Save()
	End Sub

	Private Sub InitializeMenu()
		Dim names = System.IO.Ports.SerialPort.GetPortNames()
		serialPorts.Items.AddRange(names)
		If names.Contains(cfg.SerialPort) Then
			serialPorts.SelectedItem = cfg.SerialPort
		End If
	End Sub




	Private Sub InitializeReadingDevice()
		Dim device As String = cfg.SerialPort
		Try
			If [String].IsNullOrEmpty(device) AndAlso Not TrySerialPort(device) Then
				Return
			End If

			UnsubscribeReader()
			reader = New SerialReader(device)
			AddHandler reader.Loaded, AddressOf OnDataLoaded
		Catch ex As IOException
			Dim message As String = ex.Message
			MessageBox.Show(message, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.[Error])
		End Try
	End Sub


	Protected Function TrySerialPort(ByRef device As String) As Boolean
		device = [String].Empty
		Dim ports = System.IO.Ports.SerialPort.GetPortNames()
		Select Case ports.Length
			Case 0
				MessageBox.Show(ResStrings.SerialPortNotFound, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.[Error])
				Return False
			Case 1
				cfg.SerialPort = ports(0)
				device = ports(0)
				Return True
			Case Else
				MessageBox.Show(ResStrings.SelectSerialPort, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Warning)
				Return False
		End Select
	End Function




	Private Sub UnsubscribeReader()
		If reader IsNot Nothing Then
			RemoveHandler reader.Loaded, AddressOf OnDataLoaded
			reader.IDisposable_Dispose()
		End If
	End Sub

	Public Sub MM()
		MessageBox.Show("l;'")
	End Sub


	Public Sub OnDataLoaded(sender As Object, e As EventArgs(Of String))
		'	var dl = new DriverLicense();
		'			if (dl.ExtractInfo(e.Data))
		'			{
		'				if (InvokeRequired)
		'					Invoke(new MethodInvoker(() => licenses.Add(new DriverLicensePresenter(dl))));
		'				else 
		'					licenses.Add(new DriverLicensePresenter(dl));
		'			}

	End Sub

	Private Sub _okBtn_Click(sender As Object, e As EventArgs) Handles _okBtn.Click
		Close()
	End Sub

	Private Sub _openBtn_Click(sender As Object, e As EventArgs) Handles _openBtn.Click
		'    MessageBox.Show( scannedText );
		'_dl.KeyboardReader = false;
		Dim res As Boolean = _dl.ExtractInfo(scannedText)
		If Not res Then
			'  _dl.KeyboardReader = !_dl.KeyboardReader;
			res = _dl.ExtractInfo(scannedText)
		End If

		If Not res Then
			MessageBox.Show("Error", "Cannot parse the driver license")
		Else
			tbf.Text = _dl.FirstName
		End If
		tbl.Text = _dl.LastName
		_address.Text = _dl.Address1

	End Sub

	Private Sub serialPorts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles serialPorts.SelectedIndexChanged
		cfg.SerialPort = serialPorts.SelectedItem.ToString()
		InitializeReadingDevice()
	End Sub

	Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		_computerId.Text = DriverLicense.ComputerId
	End Sub
End Class