﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO.Ports
Imports System.Windows.Forms
'using DlpLibDemo2;


Namespace DlpLibDemoVB

	Public Class SerialReader
		Implements IDisposable
		Private serialPort As SerialPort = Nothing
		Protected Const TIMEOUT As Integer = 500
		Protected timer As System.Threading.Timer = Nothing
		Protected data As New StringBuilder()
		Public Event Loaded As EventHandler(Of EventArgs(Of String))

		Public Sub New(port As String)
			timer = New Threading.Timer(AddressOf TimerExpired, Me, Threading.Timeout.Infinite, Threading.Timeout.Infinite)
			serialPort = New SerialPort(port)
			AddHandler serialPort.DataReceived, AddressOf serialPort_DataReceived
			serialPort.Open()
		End Sub

		Private Sub serialPort_DataReceived(sender As Object, e As SerialDataReceivedEventArgs)
			data.Append(serialPort.ReadExisting())
			Restart()
		End Sub

		Private Sub OnLoaded(data As String)
			' MessageBox.Show(data);
			'      MainForm._AdressText(data);
			MessageBox.Show("The ID info has been received. Click OK and then 'Populate Fields' button", "Success", MessageBoxButtons.OK)
			MainForm.scannedText = data
			RaiseEvent Loaded(Me, New EventArgs(Of String)(data))
		End Sub

		Private Shared Sub TimerExpired(instance As Object)
			Dim reader = DirectCast(instance, SerialReader)
			If reader.data.Length <> 0 Then
				Dim str As String = reader.data.ToString()
				reader.data.Remove(0, reader.data.Length)
				reader.OnLoaded(str)
			End If
		End Sub

		Protected Sub Restart()
			timer.Change(TIMEOUT, Threading.Timeout.Infinite)
		End Sub

		#Region "IDisposable Members"

        Public Sub IDisposable_Dispose() Implements IDisposable.Dispose
            timer.Dispose()
            serialPort.Dispose()
			GC.SuppressFinalize(Me)
        End Sub

#End Region
    End Class

End Namespace